﻿-- Upgrade script to 3.3 from 3.2.

CREATE TABLE CONTENT_CONSTRAINT
(
       CONT_CONS_ID NUMBER(18) NOT NULL,
       ACTUAL_DATA NUMBER(1) DEFAULT 1 NOT NULL,
       PERIODICITY varchar2(50) NULL,
       OFFSET varchar2(50) NULL,
       TOLERANCE varchar2(50) NULL
)
;

CREATE TABLE CONTENT_CONSTRAINT_ATTACHMENT
(
       CONT_CONS_ID NUMBER(18) NOT NULL,
       ART_ID NUMBER(18) NOT NULL
)
;

CREATE TABLE CUBE_REGION
(
       CUBE_REGION_ID NUMBER(18) NOT NULL,
       CONT_CONS_ID NUMBER(18) NOT NULL,
       INCLUDE NUMBER(1) DEFAULT 1 NOT NULL
)
;

CREATE TABLE CUBE_REGION_KEY_VALUE
(
	CUBE_REGION_KEY_VALUE_ID NUMBER(18) NOT NULL,
	CUBE_REGION_ID NUMBER(18) NOT NULL,
	MEMBER_ID VARCHAR2(50) NOT NULL,
	COMPONENT_TYPE VARCHAR2(50) NOT NULL,
	INCLUDE NUMBER(1) DEFAULT 1 NOT NULL
)
;
CREATE TABLE CUBE_REGION_VALUE
(
	CUBE_REGION_KEY_VALUE_ID NUMBER(18) NOT NULL,
	MEMBER_VALUE VARCHAR2(50) NOT NULL,
	INCLUDE NUMBER(1) DEFAULT 1 NOT NULL
)
;

ALTER TABLE CUBE_REGION ADD CONSTRAINT PK_CUBE_REGION
    PRIMARY KEY(CUBE_REGION_ID)
;

ALTER TABLE CUBE_REGION_VALUE ADD CONSTRAINT PK_CUBE_REGION_VALUE
    PRIMARY KEY(CUBE_REGION_KEY_VALUE_ID, MEMBER_VALUE)
;

ALTER TABLE CUBE_REGION_KEY_VALUE ADD CONSTRAINT PK_CUBE_REGION_KEY_VALUE
    PRIMARY KEY(CUBE_REGION_KEY_VALUE_ID)
;

ALTER TABLE CONTENT_CONSTRAINT_ATTACHMENT ADD CONSTRAINT PK_CONTENT_CONSTRAINT_ATT
    PRIMARY KEY(CONT_CONS_ID, ART_ID)
;

ALTER TABLE CONTENT_CONSTRAINT ADD CONSTRAINT PK_CONTENT_CONSTRAINT
    PRIMARY KEY(CONT_CONS_ID)
;
CREATE SEQUENCE CUBE_REGION_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;

CREATE SEQUENCE CUBE_REGION_KEY_VALUE_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;
CREATE OR REPLACE TRIGGER SET_CUBE_REGION_ID
BEFORE INSERT
ON CUBE_REGION
FOR EACH ROW
BEGIN
  select CUBE_REGION_SEQ.NEXTVAL into :NEW.CUBE_REGION_ID FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER SET_CUBE_REGION_KEY_VALUE_ID
BEFORE INSERT
ON CUBE_REGION_KEY_VALUE
FOR EACH ROW
BEGIN
  select CUBE_REGION_KEY_VALUE_SEQ.NEXTVAL into :NEW.CUBE_REGION_KEY_VALUE_ID FROM DUAL;
END;
/
ALTER TABLE CONTENT_CONSTRAINT ADD CONSTRAINT FK_CONT_CONS_ART FOREIGN KEY(CONT_CONS_ID) REFERENCES ARTEFACT(ART_ID) ON DELETE CASCADE
;
ALTER TABLE CONTENT_CONSTRAINT_ATTACHMENT ADD CONSTRAINT FK_CONT_CONS_ATT_CONT_CONS FOREIGN KEY(CONT_CONS_ID) REFERENCES CONTENT_CONSTRAINT(CONT_CONS_ID) ON DELETE CASCADE
;
ALTER TABLE CONTENT_CONSTRAINT_ATTACHMENT ADD CONSTRAINT FK_CONT_CONS_ATT_ART FOREIGN KEY(ART_ID) REFERENCES ARTEFACT(ART_ID)
;
ALTER TABLE CUBE_REGION ADD CONSTRAINT FK_CUBE_REGION_CONT_CONS FOREIGN KEY(CONT_CONS_ID) REFERENCES CONTENT_CONSTRAINT(CONT_CONS_ID) ON DELETE CASCADE
;
ALTER TABLE CUBE_REGION_KEY_VALUE ADD CONSTRAINT FK_CUBE_REGION_KEY_CR FOREIGN KEY(CUBE_REGION_ID) REFERENCES CUBE_REGION(CUBE_REGION_ID) ON DELETE CASCADE
;
ALTER TABLE CUBE_REGION_VALUE ADD CONSTRAINT FK_CUBE_REGION_VALUE_CRKV FOREIGN KEY(CUBE_REGION_KEY_VALUE_ID) REFERENCES CUBE_REGION_KEY_VALUE(CUBE_REGION_KEY_VALUE_ID) ON DELETE CASCADE
;
CREATE OR REPLACE PROCEDURE INSERT_CONTENT_CONSTRAINT(
       p_id IN varchar2,
       p_version IN varchar2,
       p_agency IN varchar2,
       p_valid_from IN  timestamp DEFAULT NULL,
       p_valid_to IN  timestamp DEFAULT NULL,
       p_is_final IN number DEFAULT NULL,
       p_uri IN nvarchar2,
       p_last_modified IN timestamp DEFAULT NULL,
       p_actual_data NUMBER DEFAULT 1,
       p_periodicity varchar2 DEFAULT NULL,
       p_offset varchar2 DEFAULT NULL,
       p_tolerance varchar2 DEFAULT NULL,
       p_pk OUT NUMBER)
AS
BEGIN
    INSERT_ARTEFACT(p_id => p_id,p_version => p_version,p_agency => p_agency,p_valid_from => p_valid_from,p_valid_to => p_valid_to,p_is_final => p_is_final,p_uri => p_uri,p_last_modified => p_last_modified,p_pk => p_pk);
       
       INSERT INTO CONTENT_CONSTRAINT
           (CONT_CONS_ID, ACTUAL_DATA, PERIODICITY, OFFSET, TOLERANCE)
     VALUES
           (p_pk, p_actual_data, p_periodicity, p_offset, p_tolerance);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_CONSTRAINT_ATTACHMENT(
       p_art_id IN NUMBER,
       p_cont_cons_id IN NUMBER)
AS
BEGIN
       
       INSERT INTO CONTENT_CONSTRAINT_ATTACHMENT
           (CONT_CONS_ID, ART_ID)
     VALUES
           (p_cont_cons_id, p_art_id);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_CUBE_REGION(
       p_cont_cons_id IN NUMBER,
       p_include IN NUMBER,
       p_pk OUT NUMBER)
AS
BEGIN
       INSERT INTO CUBE_REGION
           (CONT_CONS_ID, INCLUDE)
     VALUES
           (p_cont_cons_id, p_include);
       select CUBE_REGION_SEQ.currval into p_pk from dual;
END;
/

CREATE OR REPLACE PROCEDURE INSERT_CUBE_REGION_KEY_VALUE(
	p_cube_region_id IN NUMBER,
	p_member_id IN varchar2,
	p_component_type IN varchar2,
	p_include IN NUMBER,
	p_pk OUT NUMBER)
AS
BEGIN
	INSERT INTO CUBE_REGION_KEY_VALUE
           (CUBE_REGION_ID, MEMBER_ID, COMPONENT_TYPE, INCLUDE)
     VALUES
           (p_cube_region_id, p_member_id, p_component_type, p_include);
	select CUBE_REGION_KEY_VALUE_SEQ.currval into p_pk from dual;
END;
/
CREATE OR REPLACE PROCEDURE INSERT_CUBE_REGION_VALUE(
	p_cube_region_key_value_id IN NUMBER,
	p_member_value IN varchar2,
	p_include IN NUMBER)
AS
BEGIN
	INSERT INTO CUBE_REGION_VALUE
           (CUBE_REGION_KEY_VALUE_ID, MEMBER_VALUE, INCLUDE)
     VALUES
           (p_cube_region_key_value_id, p_member_value, p_include);
END;
/

declare
	hasSeq number;
begin
	select count(*) into hasSeq from user_sequences where sequence_name = 'CODE_MAP_SEQ';
	if (hasSeq = 0) then
		execute immediate 'create sequence CODE_MAP_SEQ INCREMENT BY 1 start with 1 NOMAXVALUE MINVALUE 1 NOCYCLE NOCACHE NOORDER';
	end if;
	select count(*) into hasSeq from user_sequences where sequence_name = 'COMPONENT_MAP_SEQ';
	if (hasSeq = 0) then
		execute immediate 'create sequence COMPONENT_MAP_SEQ INCREMENT BY 1 start with 1 NOMAXVALUE MINVALUE 1 NOCYCLE NOCACHE NOORDER';
	end if;
	select count(*) into hasSeq from user_sequences where sequence_name = 'ANNOTATION_SEQ';
	if (hasSeq = 0) then
		execute immediate 'create sequence ANNOTATION_SEQ INCREMENT BY 1 start with 1 NOMAXVALUE MINVALUE 1 NOCYCLE NOCACHE NOORDER';
	end if;
	select count(*) into hasSeq from user_sequences where sequence_name = 'ANNOTATION_TEXT_SEQ';
	if (hasSeq = 0) then
		execute immediate 'create sequence ANNOTATION_TEXT_SEQ INCREMENT BY 1 start with 1 NOMAXVALUE MINVALUE 1 NOCYCLE NOCACHE NOORDER';
	end if;

end;
/

CREATE OR REPLACE TRIGGER SET_CODE_MAP_DCM_ID
BEFORE INSERT
ON CODE_MAP
FOR EACH ROW
BEGIN
  SELECT CODE_MAP_SEQ.NEXTVAL
  INTO :NEW.DCM_ID
  FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER SET_COMPONENT_MAP_CM_ID
BEFORE INSERT
ON COMPONENT_MAP
FOR EACH ROW
BEGIN
  SELECT COMPONENT_MAP_SEQ.NEXTVAL
  INTO :NEW.CM_ID
  FROM DUAL;
END;
/
CREATE OR REPLACE TRIGGER SET_ANNOTATION_ANN_ID
BEFORE INSERT
ON ANNOTATION
FOR EACH ROW
BEGIN
  SELECT ANNOTATION_SEQ.NEXTVAL
  INTO :NEW.ANN_ID
  FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER SET_ANNOTATION_TEXT_ANN_TXT_ID
BEFORE INSERT
ON ANNOTATION_TEXT
FOR EACH ROW
BEGIN
  SELECT ANNOTATION_TEXT_SEQ.NEXTVAL
  INTO :NEW.ANN_TEXT_ID
  FROM DUAL;
END;
/



-- always last
update DB_VERSION SET VERSION = '3.3'
;
